// Copyright (C) 2005-2007 CEREA
//     Author(s): Lin Wu
//
// CEREA (http://www.enpc.fr/cerea/) is a joint laboratory of ENPC
// (http://www.enpc.fr/) and EDF R&D (http://www.edf.fr/).
//
// This file is part of the air quality modeling system Polyphemus.
//
// Polyphemus is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free
// Software Foundation; either version 2 of the License, or (at your option)
// any later version.
//
// Polyphemus is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
// more details.
//
// For more information, please see the Polyphemus web site:
//     http://www.enpc.fr/cerea/polyphemus/


#ifndef POLYPHEMUS_FILE_DRIVER_SEQUENTIALDRIVER_HXX


#include "AssimilationDriver.cxx"
#include <map>


namespace Polyphemus
{


  //////////////////////
  // SEQUENTIALDRIVER //
  //////////////////////


  /*! \brief This class is the base class for most sequential
    data-assimilation drivers. */
  template<class T, class ClassModel, class ClassOutputSaver,
	   class ClassObsManager>
  class SequentialDriver:
    public AssimilationDriver<T, ClassModel, ClassOutputSaver,
			      ClassObsManager>
  {

  protected:

  public:

    /*** Constructor and destructor ***/

    SequentialDriver(string config_file);
    virtual ~SequentialDriver();

    virtual void Run();

  };


} // namespace Polyphemus.


#define POLYPHEMUS_FILE_DRIVER_SEQUENTIALDRIVER_HXX
#endif
